﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using PolyLib;
using System.Threading.Tasks;
using System.Collections.Concurrent;
using System.Numerics;

namespace Braids
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            this.Title = "Braids v" + System.Diagnostics.FileVersionInfo.GetVersionInfo("Braids.exe").FileVersion + 
                " + PolyLib v" + System.Diagnostics.FileVersionInfo.GetVersionInfo("PolyLib.dll").FileVersion;
        }

        private void ComputeButton_Click(object sender, RoutedEventArgs e)
        {
            //try
            //{
            Time.Milliseconds = 0;
                DateTime t1 = DateTime.Now;
                Word w = Parser.Parse(WordTextBox.Text);
                if (HeckeRadioButton.IsChecked == true)
                {
                    Polynomial p = w.TraceHecke();
                    richTextBox1.AppendText(Environment.NewLine + p.ToStringMaple() + Environment.NewLine);
                }
                else if (YokonumaHeckeRadioButton.IsChecked == true)
                {
                    Polynomial p = w.TraceYokonumaHecke(Convert.ToInt32(YokonumaTextBox.Text));// *new Polynomial(new MultiVarTerm(1, 'z', -w.Degree()));
                    richTextBox1.AppendText(Environment.NewLine + p.ToStringMaple() + Environment.NewLine);
                }
                DateTime t2 = DateTime.Now;
                //richTextBox1.AppendText("Time: " + (t2 - t1).TotalSeconds);
                richTextBox1.AppendText("Total: " + (t2 - t1).TotalSeconds.ToString() + Environment.NewLine);
                richTextBox1.AppendText("Polynomial Multiplications: " + (Time.Milliseconds / 1000).ToString() + Environment.NewLine);
            //}
            //catch (Exception ex)
            //{
            //    richTextBox1.AppendText("Calculation suspended. Reason: \"" + ex.Message + "\"");
            //}
        }

        private void printWord(List<int[]> word)
        {
            for (int i = 0; i < word.Count; i++)
            {
                richTextBox1.AppendText("g" + word[i][0]);
                if (word[i][1] != 1)
                    richTextBox1.AppendText("^" + word[i][1]);
            }
            richTextBox1.AppendText(Environment.NewLine);
        }

        private void ComputeTestButton_Click(object sender, RoutedEventArgs e)
        {
            //try
            //{
                DateTime dt1 = DateTime.Now;

                List<string> words1 = new List<string>();
                List<string> words2 = new List<string>();
                List<string> pqr = new List<string>();

                int count = 6;

                if (Test1RadioButton.IsChecked == true)
                {

                    for (int p = 2; p < count; p++)
                        for (int q = 2; q < count; q++)
                            for (int r = 2; r < count; r++)
                            {
                                if (q != r && p + 1 != q)
                                {
                                    int framing = 2 * (p + q + r) - 3;
                                    words1.Add("t1^" + framing + " g1^" + Convert.ToString(2 * p + 1) + " g2^" + Convert.ToString(2 * q) + " g1^" + Convert.ToString(2 * r) + " g2^-1");
                                    words2.Add("t1^" + framing + " g1^" + Convert.ToString(2 * p + 1) + " g2^-1" + " g1^" + Convert.ToString(2 * r) + " g2^" + Convert.ToString(2 * q));
                                    pqr.Add("p = " + p + ", q = " + q + ", r = " + r);
                                }
                            }
                }
                else if (Test2RadioButton.IsChecked == true)
                {
                    for (int a = 2; a < count; a++)
                        for (int b = 2; b < count; b++)
                        {
                            int framing = 2 * (a + b + 2) - 4;
                            words1.Add("t1^" + framing + "g3g2^-2g3" + Convert.ToString(2 * a + 2) + " g2g3^-1g1^-1g2g1^" + Convert.ToString(2 * b + 2));
                            words2.Add("t1^" + framing + "g3g2^-2g3" + Convert.ToString(2 * a + 2) + " g2g3^-1g1^" + Convert.ToString(2 * b + 2) + "g2g1^-1");
                        }
                }

                DateTime dt2 = DateTime.Now;

                List<string> output = new List<string>();
                richTextBox1.AppendText(words1.Count.ToString() + " pairs of words to be calculated.\r");

                for (int i = 0; i < words1.Count; i++)
                {
                    Word w1 = Parser.Parse(words1[i]);
                    Word w2 = Parser.Parse(words2[i]);
                    if (HeckeRadioButton.IsChecked == true)
                    {
                        Polynomial p1 = w1.TraceHecke();
                        Polynomial p2 = w2.TraceHecke();
                        richTextBox1.AppendText(Environment.NewLine + p1.Count + Environment.NewLine + p2.Count + Environment.NewLine);
                        richTextBox1.AppendText(Environment.NewLine + p1.Equals(p2).ToString() + Environment.NewLine);
                        richTextBox1.AppendText(Environment.NewLine + p1.Equals(p2).ToString() + Environment.NewLine);
                    }
                    else if (YokonumaHeckeRadioButton.IsChecked == true)
                   { 
                        Polynomial p1 = w1.TraceYokonumaHecke(Convert.ToInt32(YokonumaTextBox.Text));
                        Polynomial p2 = w2.TraceYokonumaHecke(Convert.ToInt32(YokonumaTextBox.Text));
                        ComplexPolynomial c1 = Evaluate(p1, Convert.ToInt32(YokonumaTextBox.Text));
                        ComplexPolynomial c2 = Evaluate(p2, Convert.ToInt32(YokonumaTextBox.Text));
                        if (Test1RadioButton.IsChecked == true) { richTextBox1.AppendText(Environment.NewLine + pqr[i].ToString()); }
                        richTextBox1.AppendText(Environment.NewLine + w1.ToString() + Environment.NewLine + w2.ToString() + Environment.NewLine);
                        richTextBox1.AppendText(Environment.NewLine + p1.ToStringMaple() + Environment.NewLine
                            + p2.ToStringMaple() + Environment.NewLine);
                        //richTextBox1.AppendText(Environment.NewLine + c1.ToString() + Environment.NewLine + c2.ToString() + Environment.NewLine);
                        
                        bool yokonuma = p1.Equals(p2);
                        bool esystem = c1.Equals(c2);
                        
                        //richTextBox1.AppendText(Environment.NewLine + "Terms: " + c1.Count + Environment.NewLine);
                        
                        richTextBox1.AppendText(yokonuma.ToString() + Environment.NewLine);
                        //richTextBox1.AppendText(Environment.NewLine + esystem.ToString() + Environment.NewLine);

                        if (yokonuma || !esystem)
                        {
                        }
                    }
                }

                DateTime dt3 = DateTime.Now;

                richTextBox1.AppendText(Environment.NewLine + Environment.NewLine);
                //richTextBox1.AppendText("Words creation: " + (dt2 - dt1).TotalSeconds.ToString() + Environment.NewLine);
                //richTextBox1.AppendText("Parsing and calculation: " + (dt3 - dt2).TotalSeconds.ToString() + Environment.NewLine);
                richTextBox1.AppendText("Total: " + (dt3 - dt1).TotalSeconds.ToString() + Environment.NewLine);
                richTextBox1.AppendText("Commute: " + Time.Milliseconds.ToString() + Environment.NewLine);
            //}
            //catch (Exception ex)
            //{
            //    richTextBox1.AppendText("Calculation suspended. Reason: \"" + ex.Message + "\"");
            //}
        }

        private void CompareButton_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                Word w1 = Parser.Parse(Word1TextBox.Text);
                Word w2 = Parser.Parse(Word2TextBox.Text);
                if (HeckeRadioButton.IsChecked == true)
                {
                    Polynomial p1 = w1.TraceHecke();
                    Polynomial p2 = w2.TraceHecke();
                    richTextBox1.AppendText(Environment.NewLine + p1.Equals(p2).ToString() + Environment.NewLine);
                    richTextBox1.AppendText(p1.ToString() + Environment.NewLine + Environment.NewLine);
                    richTextBox1.AppendText(p2.ToString());
                }
                else if (YokonumaHeckeRadioButton.IsChecked == true)
                {
                    Polynomial p1 = w1.TraceYokonumaHecke(Convert.ToInt32(YokonumaTextBox.Text));
                    Polynomial p2 = w2.TraceYokonumaHecke(Convert.ToInt32(YokonumaTextBox.Text));
                    ComplexPolynomial c1 = Evaluate(p1, Convert.ToInt32(YokonumaTextBox.Text));
                    ComplexPolynomial c2 = Evaluate(p2, Convert.ToInt32(YokonumaTextBox.Text));
                    richTextBox1.AppendText(Environment.NewLine + p1.ToStringMaple() + Environment.NewLine + p2.ToStringMaple() + Environment.NewLine);
                    richTextBox1.AppendText(Environment.NewLine + c1.ToString() + Environment.NewLine + c2.ToString() + Environment.NewLine);
                    richTextBox1.AppendText(Environment.NewLine + c1.Count + Environment.NewLine + c2.Count + Environment.NewLine);
                    richTextBox1.AppendText(Environment.NewLine + p1.Equals(p2).ToString() + Environment.NewLine);
                    richTextBox1.AppendText(Environment.NewLine + c1.Equals(c2).ToString() + Environment.NewLine);
                }
            }
            catch (Exception ex)
            {
                richTextBox1.AppendText("Calculation suspended. Reason: \"" + ex.Message + "\"");
            }
            
        }

        private Complex[] ESystemSolutions(int d)
        {
            Complex[] solutions = new Complex[d - 1];
            for (int i = 0; i < d - 1; i++)
            {
                //for (int j = 1; j < d; j++)
                    solutions[i] += new Complex(Math.Round(Math.Cos(2 * Math.PI * i / d), 3), Math.Round(Math.Sin(2 * Math.PI * i / d), 3));
                   // solutions[i] = solutions[i];// / d;
            }
            return solutions;
        }

        private ComplexPolynomial Evaluate(Polynomial p, int d)
        {
            Complex[] sols = ESystemSolutions(d);

            ComplexPolynomial result = new ComplexPolynomial();
            foreach (MultiVarTerm t in p)
            {
                ComplexVarTerm res = new ComplexVarTerm(t.Coefficient);
                foreach (char c in t.Variables.Keys)
                {
                    if (c > 64 && c < 91)
                        res.Coefficient *= Complex.Pow(sols[c - 65], (double)t.Variables[c]);
                    else if (c == 'd')
                        res.Coefficient *= Math.Pow(d, (double)t.Variables[c]);
                    else
                        res.Variables.Add(c, t.Variables[c]);
                }
                result.Add(res);
            }
            for (int i=0; i < result.Count; i++)
            {
                result[i].Coefficient = new Complex(Math.Round(result[i].Coefficient.Real, 3), Math.Round(result[i].Coefficient.Imaginary, 3));
                //if (t.Coefficient == Complex.Zero)
                //{
                //    result.Remove(t);
                //}
            }
            return result;
        }

        private void OpenFilesButton_Click(object sender, RoutedEventArgs e)
        {
            Microsoft.Win32.OpenFileDialog open = new Microsoft.Win32.OpenFileDialog();
            open.Filter = "Text files (*.txt)|*.txt";
            open.Title = "Select the 1st file";
            bool? result = open.ShowDialog();
            if (result.HasValue && (bool)result)
                richTextBox1.AppendText(Environment.NewLine + "Input from file (1): " + open.FileName + Environment.NewLine);           

            System.IO.StreamReader read = new System.IO.StreamReader(open.FileName);
            List<string> words1 = new List<string>();

            while (!read.EndOfStream)
                words1.Add(read.ReadLine());
            read.Close();
            ConvertNotation(ref words1);

            open.Title = "Select the 2nd file";
            result = open.ShowDialog();

            if (result.HasValue && (bool)result)
                richTextBox1.AppendText("Input from file (2): " + open.FileName + Environment.NewLine);

            read = new System.IO.StreamReader(open.FileName);
            List<string> words2 = new List<string>();

            while (!read.EndOfStream)
                words2.Add(read.ReadLine());
            read.Close();
            ConvertNotation(ref words2);

            //int numProcs = Environment.ProcessorCount;

            for(int i = 0; i < words1.Count; i++)
            {
                //Word w1 = Parser.Parse(words1[i]);
                //Word w2 = Parser.Parse(words2[i]);
                //if (w1.Braiding[w1.FindMaxIndexes(w1.Braiding)[0]][0] != w2.Braiding[w2.FindMaxIndexes(w2.Braiding)[0]][0])
                //    richTextBox1.AppendText(Environment.NewLine + i + " strands");
                //if(w1.ExpSum() != w2.ExpSum())
                //    richTextBox1.AppendText(Environment.NewLine + i + " expsum");
                Polynomial poly1 = Parser.Parse(words1[i]).TraceHecke();
                Polynomial poly2 = Parser.Parse(words2[i]).TraceHecke();
                if (poly1.ToString() != poly2.ToString())
                    richTextBox1.AppendText("False :" + i + Environment.NewLine);
                //polys1[i] = Parser.Parse(words1[i]).TraceYokonumaHecke(Convert.ToInt32(YokonumaTextBox.Text));
                //polys2[i] = Parser.Parse(words2[i]).TraceYokonumaHecke(Convert.ToInt32(YokonumaTextBox.Text));
            }   
        }

        private void ConvertNotation(ref List<string> words)
        {
            String temp;

            System.Text.StringBuilder maple = new System.Text.StringBuilder();
            System.IO.StreamWriter[] write = new System.IO.StreamWriter[10];
            System.IO.StreamWriter[] write_same = new System.IO.StreamWriter[10];

            for (int i = 0; i < write.Length; i++)
            {
                write[i] = new System.IO.StreamWriter("F:\\Users\\Konstantinos\\Dropbox\\Chmutov\\testBraids\\SameHomNon_" + i + ".txt");
                write_same[i] = new System.IO.StreamWriter("F:\\Users\\Konstantinos\\Dropbox\\Chmutov\\testBraids\\Links_same_" + i + ".txt");
            }

            List<List<string>> newWords = new List<List<string>>();
            newWords.Add(new List<string>());
            int count = 0;

            for (int i = 0; i < words.Count; i++)
            {
                if (words[i] == "\"0\"")
                {
                    newWords.Add(new List<string>());
                    count++;
                }
                else
                {
                    newWords[count].Add(words[i]);
                }
            }


            for (int i = 0; i < newWords.Count - 1; i++)
            {
                int[] max = new int[newWords[i].Count];
                int[] expsum = new int[newWords[i].Count];

                for (int k = 0; k < newWords[i].Count; k++)
                {
                    temp = newWords[i][k];
                    int index = 0;
                    for (int j = 0; j < temp.Length; j++)
                    {
                        if (temp[j] > 64 && temp[j] < 91) //Uppercase letter -> positive power
                        {
                            index = temp[j] - 64;
                            expsum[k]++;
                            if (index > max[k]) { max[k] = index; }
                            maple.Append((index + " ").ToString());
                            //if (max < index) { max = index; }
                        }
                        else if (temp[j] > 96 && temp[j] < 123) //Lowercase letter --> negative power
                        {
                            index = temp[j] - 96;
                            expsum[k]--;
                            if (index > max[k]) { max[k] = index; }
                            maple.Append("-" + (index + " ").ToString());
                        }
                    } 
                    maple.Append(Environment.NewLine);
                }
                Console.WriteLine(expsum.ToString());

                bool diff = false;
                for (int k = 1; k < max.Length; k++)
                    diff = max[k - 1] != max[k];

                if (diff)
                {
                    write[max.Max()].WriteLine(maple.ToString());
                }
                else
                {
                    write_same[max.Max()].WriteLine(maple.ToString());
                }

                maple.Clear();
            }
            for (int i = 0; i < write.Length; i++)
            {
                write[i].Close();
                write_same[i].Close();
            }
        }

        private void ConvertNotation2(ref List<string> words)
        {
            System.Text.StringBuilder str = new System.Text.StringBuilder();

            str.Append("words := [");

            for (int i = 0; i < words.Count; i++)
            {
                String[] temp = words[i].Split(' ');
            }
        }

        private void File2Button_Click(object sender, RoutedEventArgs e)
        {

        }

    }
}
