﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Braids
{
    /// <summary>
    /// Parses a string and converts it to a word
    /// </summary>
    public static class Parser
    {
        /// <summary>
        /// Checks if the string is a valid word
        /// </summary>
        /// <param name="word">The string</param>
        /// <returns>A List of String containing the elements of the word</returns>
        private static List<String> Validate(String word)
        {
            List<String> output = new List<String>();

            String str = "";
            if (!(word[0] == 'g' || word[0] == 't')) { throw new Exception("Word must begin with g or t"); }
            str = word[0].ToString();
            for (int i = 1; i < word.Length; i++)
            {
                if (word[i] == 'g' || word[i] == 't')
                {
                    output.Add(str);
                    if (str.IndexOf('^') != str.LastIndexOf('^'))
                        throw new Exception("Check the syntax of the word");
                    str = word[i].ToString();
                }
                else
                {
                    str += word[i];
                }
            }
            output.Add(str);

            return output;
        }

        /// <summary>
        /// Parses a word
        /// </summary>
        /// <param name="word">The word</param>
        /// <returns>A word object</returns>
        public static Word Parse(String word)
        {
            List<int[]> output = new List<int[]>();
            try
            {
                List<String> input = Validate(word);
                string[] temp;
                string s;
                int t0, t1, t2;
                for (int i=0; i<input.Count; i++)
                {
                    s = input[i];
                    s = s.Replace("(", ""); //Future use
                    s = s.Replace(")", ""); //Future use
                    
                    t0 = s[0];
                    s = s.Remove(0, 1);
                    if (s.Contains('^'))
                    {
                        temp = s.Split('^');
                        t1 = Convert.ToInt32(temp[0]);
                        t2 = Convert.ToInt32(temp[1]);
                        output.Add( new int[] {t0, t1, t2});
                    }
                    else
                    {
                        t1 = Convert.ToInt32(s);
                        output.Add(new int[] { t0, t1, 1});
                    }
                }

                Word outWord = new Word(output);
                return outWord;
            }
            catch (Exception e)
            {
                throw e;
            }
        }
    }
}
